//+------------------------------------------------------------------+ 
//|               TRO_RECTANGLE                                      | 
//|                                                                  | 
//|   Copyright  2011, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2011, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 2
#property indicator_color1 MediumVioletRed 
#property indicator_color2 DodgerBlue 
 
//+--------- TRO MODIFICATION ---------------------------------------+ 
  
extern bool   Show.Boxes  = true ;
extern bool   Show.Labels = true ;
extern int    ShiftLabel  =  10 ;
  
extern string myLabel     = "Resistance" ; 
extern color colorSHADE   = Magenta ;
 
 
extern double PRICE1 = 1.3750 ; 
extern double PRICE2 = 1.3700 ; 

extern double Line_Style    = STYLE_DASH ;
extern int    myWidth   = 1 ;

//+--------- TRO MODIFICATION ---------------------------------------+ 
string symbol, tChartPeriod,  ShortName, MESSAGE ;  
int    digits, period  ; 
double   point; 

bool  PLOTLINE, GREEN;

string   labelNames, TAG;

int      totalLabels;
int      LinesPlotted;  

int limit,i, HIGHBAR, LOWBAR; 
   
double    xThreshold, HIGHLINE, LOWLINE, close, open ;  
 
//+------------------------------------------------------------------+ 
int init() 
{ 
  
   period       = Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
  
   TAG       = "RECTANGLE" ;
   ShortName = TAG + symbol + tChartPeriod  ;
  labelNames = ShortName; 
  
   return(0); 
} 
  

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+ 
int deinit() 
  { 

   ObDeleteObjectsByPrefix(TAG);  
   TRO();
   
   return(0); 
  } 


//+------------------------------------------------------------------+ 

int start() 
  { 
 
   deinit() ;
   
  limit = WindowBarsPerChart() ;  
   
        if (ObjectFind(ShortName+"61") != 0)
        ObjectCreate(ShortName+"61", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"61", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"61", OBJPROP_PRICE1, PRICE1);
        ObjectSet(ShortName+"61", OBJPROP_TIME2, Time[limit]);
        ObjectSet(ShortName+"61", OBJPROP_PRICE2, PRICE2  ); // ATR + D1_low 
        ObjectSet(ShortName+"61", OBJPROP_COLOR, colorSHADE);
        ObjectSet(ShortName+"61", OBJPROP_BACK, true);         

 
     
      setLine(next(), myLabel + " " + DoubleToStr(PRICE1, digits), colorSHADE, PRICE1 );      
      setLine(next(), myLabel + " " + DoubleToStr(PRICE2, digits), colorSHADE, PRICE2 );         
     
   WindowRedraw();
                   
   return(0);
}

 
     
//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}



//+------------------------------------------------------------------+

string next() { totalLabels++; return(totalLabels); }  

//+------------------------------------------------------------------+
void setLine(string name, string text, color theColor, double srprice )
{


   string labelName = StringConcatenate(labelNames,name);


      if (ObjectFind(labelName) != 0)
      {

            ObjectCreate(labelName, OBJ_TREND, 0, Time[i], srprice,Time[0],srprice);
            ObjectSet(labelName, OBJPROP_STYLE, Line_Style);
            ObjectSet(labelName, OBJPROP_COLOR, theColor);
            ObjectSet(labelName,OBJPROP_WIDTH,myWidth);
            ObjectSet(labelName,OBJPROP_RAY,false); 

         
      } // if
      
   if(Show.Labels)
   {         

      datetime LabelTime = Time[0]+Period()*60*ShiftLabel ;
      
      string Obj0002 = labelName+"linelbl" ;
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, srprice);
         ObjectSetText(Obj0002,text , 8, "Arial", theColor);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, srprice);
      } // if 
                 
   } // if  
   
   if(Show.Boxes)
   {  
     string dName = labelName+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],srprice);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,theColor);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],srprice);
      } 
   } // if     
      
}       

//+------------------------------------------------------------------+  
void TRO()
{   

   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
  
//+------------------------------------------------------------------+
/*

Comment( 
"high0 = ", DoubleToStr(high0 , digits), "\n",        
"high1 = ", DoubleToStr(high1 , digits), "\n",  
"high2 = ", DoubleToStr(high2 , digits), "\n",  
"Low0 = ", DoubleToStr(Low0 , digits), "\n",        
"Low1 = ", DoubleToStr(Low1 , digits), "\n",  
"Low2 = ", DoubleToStr(Low2 , digits), "\n",  
"") ; 

  


*/