//+------------------------------------------------------------------+ 
//|   TRO_BAR_TRADE                                                  | 
//|                                                                  | 
//|   Copyright  2011, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2011, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0

//---- indicator parameters  
 
extern bool InsideBar=true;
extern bool OutSideBar=true;
extern bool KeyReversalBar=true;
extern bool TwoBarReversal=true;

extern int win = 0;
extern int price.x.offset= 0 ; 
extern int price.y.offset= 10 ; 
extern int myFontSize       = 12;

extern string Buy_Message  = "BUY" ;
extern string Wait_Message = "WAIT" ;
extern string Sell_Message = "SELL" ;


extern color Buy_color = Lime;
extern color Wait_color = DimGray;
extern color Sell_color = Red;


int    shift=1;			//shift to current bar, 

int isins,isouts,iskeyrev,is2brev;
bool buysig,sellsig,closebuy,closesell ;
 
 
string tMessage , oldmsg = "" ; 

string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
double point;
   double nHH, nLL, ClLo, HiCl, close; 
   
   
datetime Trigger ;

int OldBars = -1 ;
int  BARNUM ;
color tColor = Yellow, ClOpColor;  
 
double buyPB[];
double sellPB[];
double insideBar[];
double arrayGaps[];
double outsideBars[];
double smallSR[];
int startDay=2000;
static int prevTime;
double dayRange = 0.0;
int outsideBarsCount=0;

   string info="";
   string time="";
   bool addInfo=false;
   int outsideBarDirection;
   int hours, min, sec;
   double gapSize;
   bool alertOn;
   int smallSRcount=0;
    
double O, H, L, C ;
double O1, H1, L1, C1 ; 
double O2, H2, L2, C2 ;
double O3, H3, L3, C3 ;
 
//+------------------------------------------------------------------+ 
int init() 
{ 
   period       = Period() ;     
   symbol       = Symbol() ;
   digits       = Digits ;   
   point        = Point ;
   
   tChartPeriod =  TimeFrameToString(period) ;
      
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   

   deinit();
   
   return(0); 
  } 

//+------------------------------------------------------------------+ 
int deinit() 
{ 

   
   ObjectDelete("bTR930");
   ObjectDelete("bTR929");
   ObjectDelete("bTR929B");
   ObjectDelete("bTR931");
   ObjectDelete("bTR932");
   ObjectDelete("bTR934");   
   
   ObjectDelete("bTR930");
   ObjectDelete("bTR929");
   ObjectDelete("bTR929B");
   ObjectDelete("bTR931");
   ObjectDelete("bTR932");
   ObjectDelete("bTR934");   
   
   TRO();
   
   return(0); 
}  
 
//+------------------------------------------------------------------+ 
int start() 
{ 

tMessage = "" ;
   
O  = iOpen( symbol, period, 0) ;
H  = iHigh( symbol, period, 0 ) ;
L  = iLow( symbol, period, 0) ;
C  = iClose( symbol, period, 0) ;

O1  = iOpen( symbol, period, 1) ;
H1  = iHigh( symbol, period, 1) ;
L1  = iLow( symbol, period, 1) ;
C1  = iClose( symbol, period, 1) ; 

O2  = iOpen( symbol, period, 2) ;
H2  = iHigh( symbol, period, 2 ) ;
L2  = iLow( symbol, period, 2) ;
C2  = iClose( symbol, period, 2) ;

O3  = iOpen( symbol, period, 3) ;
H3  = iHigh( symbol, period, 3 ) ;
L3  = iLow( symbol, period, 3) ;
C3  = iClose( symbol, period, 3) ;   
   
CheckForSignals() ;

         BARNUM = iBarShift(NULL,PERIOD_D1,Time[0]) ;
         nHH    = iHigh(NULL,PERIOD_D1,BARNUM); 
         nLL    = iLow(NULL,PERIOD_D1,BARNUM);  

close   = Close[0] ;
ClLo    = (close - nLL) / point ;
HiCl    = (nHH - close) / point ;

 
   if( ClLo < 20 && HiCl > 20 ) { tMessage = "<GREEN RAT BUY> " ; ClOpColor = Buy_color ; }
   if( ClLo > 20 && HiCl < 20 ) { tMessage = "<RED RAT SELL> " ; ClOpColor = Sell_color ; }
 


while(true)
{

if( buysig ) { tMessage = tMessage + Buy_Message ; ClOpColor = Buy_color ; break ; }

if( sellsig )  { tMessage =  tMessage + Sell_Message ; ClOpColor = Sell_color ;  break ;  }  


break;

} // while

tMessage = tChartPeriod + " " + tMessage + " " + symbol ;

if(isins != 0 ) { tMessage = tMessage + " <Inside Bar>" ; }
if(isouts != 0 ) { tMessage = tMessage + " <Outside Bar>" ; }
if(iskeyrev != 0 ) { tMessage = tMessage + " <Key Reversal Bar>" ; }
if(is2brev != 0 ) { tMessage = tMessage + " <2 Bar Reversal>" ; }


if (IsBuyPinbar(dayRange,0)) { tMessage = tMessage + " <PinBar BUY>" ; }
if (IsSellPinbar(dayRange,0)) { tMessage = tMessage + " <PinBar SELL>" ; }


  if(H1 == H2) { tMessage = tMessage + " <Double Top>" ; }
  if(L1 == L2) { tMessage = tMessage + " <Double Bottom>" ; }

  if(H2 > H3 && H2 > H1 ) { tMessage = tMessage + " <1-2-3 Top>" ; }
  if(L2 < L3 && L2 < L1 ) { tMessage = tMessage + " <1-2-3 Bottom>" ; }  

if((C1 > O1) && (O > C) && (O >= C1) && (O1 >= C) && ((O - C) > (C1 - O1))) 
{ tMessage = tMessage + " <Bearish Engulfing>" ; }  

if((C2 > O2) && (O1 > C1) && (O1 >= C2) && (O2 >= C1) && ((O1 - C1) > (C2 - O2)) && (O > C) && (C < C1)) 
{ tMessage = tMessage + " <Three Outside Down>" ; }  

if((C1 > O1) && (((C1 + O1) / 2) > C) && (O > C) && (O > C1) && (C > O1) && ((O - C) / (0.001 + (H - L)) > 0.6)) 
{ tMessage = tMessage + " <Dark Cloud Cover>" ; } 

if((C2 > O2) && ((C2 - O2) / (0.001 + H2 - L2) > 0.6) && (C2 < O1) && (C1 > O1) && ((H1-L1) > (3*(C1 - O1))) && (O > C) && (O < O1)) 
{ tMessage = tMessage + " <Evening Doji Star>" ; } 

if((C1 > O1) && (O > C) && (O <= C1) && (O1 <= C) && ((O - C) < (C1 - O1))) 
{ tMessage = tMessage + " <Bearish Harami>" ; } 

if((C2 > O2) && (O1 > C1) && (O1 <= C2) && (O2 <= C1) && ((O1 - C1) < (C2 - O2)) && (O > C) && (C < C1) && (O < O1)) 
{ tMessage = tMessage + " <Three Inside Down>" ; } 

if((O > C*1.01) && (O1 > C1*1.01) && (O2 > C2*1.01) && (C < C1) && (C1 < C2) && 
          (O > C1) && (O < O1) && (O1 > C2) && (O1 < O2) && (((C - L) / (H - L)) < 0.2) && 
          (((C1 - L1) / (H1 - L1)) < 0.2) && (((C2 - L2) / (H2 - L2)) < 0.2))
{ tMessage = tMessage + " <Three Black Crows>" ; } 

if((C2 > O2) && ((C2 - O2) / (0.001 + H2 - L2) > 0.6) && (C2 < O1) && (C1 > O1) && 
          ((H1 - L1) > (3*(C1 - O1))) && (O > C) && (O < O1)) 
{ tMessage = tMessage + " <Evening Star>" ; } 

if((O1 > C1) && (C > O) && (C >= O1) && (C1 >= O) && ((C - O) > (O1 - C1))) 
{ tMessage = tMessage + " <Bullish Engulfing>" ; } 

if((O2 > C2) && (C1 > O1) && (C1 >= O2) && (C2 >= O1) && ((C1 - O1) > (O2 - C2)) && (C > O) && (C > C1)) 
{ tMessage = tMessage + " <Three Outside Up>" ; } 

if((O1 > C1) && (C > O) && (C <= O1) && (C1 <= O) && ((C - O) < (O1 - C1))) 
{ tMessage = tMessage + " <Bullish Harami>" ; }

if((O2 > C2) && (C1 > O1) && (C1 <= O2) && (C2 <= O1) && ((C1 - O1) < (O2 - C2)) && (C > O) && (C > C1) && (O > O1)) 
{ tMessage = tMessage + " <Three Inside Up>" ; }

if((C1 < O1) && (((O1 + C1) / 2) < C) && (O < C) && (O < C1) && (C < O1) && ((C - O) / (0.001 + (H - L)) > 0.6)) 
{ tMessage = tMessage + " <Piercing Line>" ; }

if((C > O*1.01) && (C1 > O1*1.01) && (C2 > O2*1.01) && (C > C1) && (C1 > C2) && 
          (O < C1) && (O > O1) && (O1 < C2) && (O1 > O2) && (((H - C) / (H - L)) < 0.2) && 
          (((H1 - C1) / (H1 - L1)) < 0.2) && (((H2 - C2) / (H2 - L2)) < 0.2)) 
{ tMessage = tMessage + " <Three White Soldiers>" ; }

if((O2 > C2) && ((O2 - C2) / (0.001 + H2 - L2) > 0.6) && (C2 > O1) && (O1 > C1) && 
          ((H1 - L1) > (3*(C1 - O1))) && (C > O) && (O > O1)) 
{ tMessage = tMessage + " <Morning Doji Star>" ; }














           
if(tMessage == "") {tMessage = Wait_Message ; ClOpColor = Wait_color ; }



oldmsg =  tMessage ;

//+------------------------------------------------------------------+  
                    
   ObjectCreate("bTR931", OBJ_LABEL, win, 0, 0);//HiLow LABEL
   ObjectSetText("bTR931",tMessage, myFontSize , "Arial Bold", ClOpColor );
   ObjectSet("bTR931", OBJPROP_CORNER, 2);
   ObjectSet("bTR931", OBJPROP_XDISTANCE, price.x.offset); 
   ObjectSet("bTR931", OBJPROP_YDISTANCE, price.y.offset); 
 
//+------------------------------------------------------------------+        

   WindowRedraw();    
 
   return(0); 
} 
 
//+------------------------------------------------------------------+
void CheckForSignals() 
{
      //check long,short,exit signals
      buysig=false;
      sellsig=false;
      closebuy=false;
      closesell=false;

      

      if (InsideBar) isins=IsInsideBar(shift);
      if (OutSideBar) isouts=IsOutSideBar(shift);
      if (KeyReversalBar) iskeyrev=IsKeyReversalBar(shift);
      if (TwoBarReversal) is2brev=IsTwoBarReversal(shift);

      //long entry signal condition
      if (isins>0 || isouts>0 || iskeyrev>0 || is2brev>0) {
         buysig=true;
         closesell=true;
      }
      //short entry signal
      if (isins<0 || isouts<0 || iskeyrev<0 || is2brev<0) {
         buysig=false;
         sellsig=true;
         closebuy=true;
      }


}

//+------------------------------------------------------------------+
int IsInsideBar(int shift) 
{
   //Inside Bar, The close of the inside bar should be higher than both the close and the bar midpoint The current bar must open 
   //equal or higher than the close of the inside bar a BuyStop order is to be placed at the high of the inside bar if the order 
   //is not hit within the next 4 bars cancel order. See picture below
   if (High[shift]>High[shift+1]) return(0);
   if (Low[shift]<Low[shift+1]) return(0);
   if (Close[shift]>Open[shift] && Close[shift]>(High[shift]+Low[shift])/2 && Open[shift-1]>=Close[shift]) return(1);
   if (Close[shift]<Open[shift] && Close[shift]<(High[shift]+Low[shift])/2 && Open[shift-1]<=Close[shift]) return(-1);
   return(0);
}
//+------------------------------------------------------------------+
int IsOutSideBar(int shift) 
{
   //Outside Bar, The close of the outside bar should be higher than the open and higher that the bar midpoint the open 
   //of the current bar should open equal or higher than the close of the outside bar order A Buystop order should be 
   //placed on the high of the outside bar if it is not executed within the next 4 bars cancel order. See picture below
   if (High[shift]<High[shift+1]) return(0);
   if (Low[shift]>Low[shift+1]) return(0);
   if (Close[shift]>Open[shift] && Close[shift]>(High[shift]+Low[shift])/2 && Open[shift-1]>=Close[shift]) return(1);
   if (Close[shift]<Open[shift] && Close[shift]<(High[shift]+Low[shift])/2 && Open[shift-1]<=Close[shift]) return(-1);
   return(0);
}
//+------------------------------------------------------------------+
int IsKeyReversalBar(int shift) 
{
   //Key Reversal Bar, The open of the key bar should be at least ?pips higher than the high of the previous bar. 
   //The close of the key bar should be with in the high and close of the previous bar. The open of the current bar should be 
   //lower than the close of the key bar. A SellStop order should be place on the low of the key bar if it is not executed within 
   //the next 4 bars then cancel the order. See picture below - short!
   if (Open[shift]<Low[shift+1] && Close[shift]>=Low[shift+1]  && Close[shift]<=Close[shift+1] && Open[shift-1]>Close[shift]) return(1);
   if (Open[shift]>High[shift+1] && Close[shift]<=High[shift+1]  && Close[shift]>=Close[shift+1] && Open[shift-1]<Close[shift]) return(-1);
   return(0);
}

//+------------------------------------------------------------------+
int IsTwoBarReversal(int shift) 
{
   //Two Bar Reversal, The open of the first bar should be near the low the previous bar and the close should be much lower and 
   //have a good size body. The open of the second bar should be very near the close of the first bar but both should be well below 
   //the midpoint of each bar with the close to be very near the low 2 bar previous. A BuyStop Order should be place at the high of
   //the bar 1 if it is not executed within 4 bars cancel order. See picture below
   if (MathAbs(Open[shift+1]-Close[shift+1])> MathAbs(Open[shift+1]-Low[shift+2])<= 
       MathAbs(Close[shift]-Low[shift+2])<=
       MathAbs(Open[shift]-Close[shift+1]) &&
       Close[shift+1]<(High[shift+1]+Low[shift+1])/2 &&
       Open[shift]<(High[shift]+Low[shift])/2)
         return(1);
   if (MathAbs(Open[shift+1]-Close[shift+1])> MathAbs(Open[shift+1]-High[shift+2])<= 
       MathAbs(Close[shift]-Low[shift+2])<= 
       MathAbs(Open[shift]-Close[shift+1]) &&
       Close[shift+1]>(High[shift+1]+Low[shift+1])/2 &&
       Open[shift]>(High[shift]+Low[shift])/2)
         return(-1);
   return(0);
}
 



//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

 
//+------------------------------------------------------------------+ 

void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

//+------------------------------------------------------------------+ 

//+------------------------------------------------------------------+
//| User function AveRange4                                          |
//+------------------------------------------------------------------+
double AveRange4(int pos)
{
   double sum;
   double rangeSerie[4];
   
   int i=0;
   int ind=1;
   int startYear=1995;
   int den;
   
   if(pos<=0)den=1;
   else den = pos;
   if (TimeYear(Time[den-1])>=startYear)
   {
      while (i<4)
      {
         //datetime pok=Time[pos+ind];
         if(TimeDayOfWeek(Time[pos+ind])!=0)
         {
            sum+=High[pos+ind]-Low[pos+ind];//make summation
            i++;
         }
         ind++;   
         //i++;
      }
      //Comment(sum/4.0);
      return (sum/4.0);//make average, don't count min and max, this is why I divide by 4 and not by 6
   } 
      return (50*Point);
   
}//------------END FUNCTION-------------

//+------------------------------------------------------------------+
//| User function IsPinbar                                           |
//+------------------------------------------------------------------+
bool IsBuyPinbar(double& dayRange, int pos)
{
   //start of declarations
   double actOp,actCl,actHi,actLo,preHi,preLo,preCl,preOp,actRange,preRange,actHigherPart,actHigherPart1;
   actOp=Open[pos+1];
   actCl=Close[pos+1];
   actHi=High[pos+1];
   actLo=Low[pos+1];
   preOp=Open[pos+2];
   preCl=Close[pos+2];
   preHi=High[pos+2];
   preLo=Low[pos+2];
   //SetProxy(preHi,preLo,preOp,preCl);//Check proxy
   actRange=actHi-actLo;
   preRange=preHi-preLo;
   actHigherPart=actHi-actRange*0.4;//helping variable to not have too much counting in IF part
   actHigherPart1=actHi-actRange*0.4;//helping variable to not have too much counting in IF part
   //end of declaratins
   //start function body
   dayRange=AveRange4(pos);
   if((actCl>actHigherPart1&&actOp>actHigherPart)&&  //Close&Open of PB is in higher 1/3 of PB
      (actRange>dayRange*0.5)&& //PB is not too small
      //(actHi<(preHi-preRange*0.3))&& //High of PB is NOT higher than 1/2 of previous Bar
      (actLo+actRange*0.25<preLo)) //Nose of the PB is at least 1/3 lower than previous bar
   {
    
      if(Low[ArrayMinimum(Low,3,pos+3)]>Low[pos+1])
         return (true);
   }
   return(false);
   
}//------------END FUNCTION-------------


bool IsSellPinbar(double& dayRange, int pos)
{
   //start of declarations
   double actOp,actCl,actHi,actLo,preHi,preLo,preCl,preOp,actRange,preRange,actLowerPart, actLowerPart1;
   actOp=Open[pos+1];
   actCl=Close[pos+1];
   actHi=High[pos+1];
   actLo=Low[pos+1];
   preOp=Open[pos+2];
   preCl=Close[pos+2];
   preHi=High[pos+2];
   preLo=Low[pos+2];
   //SetProxy(preHi,preLo,preOp,preCl);//Check proxy
   actRange=actHi-actLo;
   preRange=preHi-preLo;
   actLowerPart=actLo+actRange*0.4;//helping variable to not have too much counting in IF part
   actLowerPart1=actLo+actRange*0.4;//helping variable to not have too much counting in IF part
   //end of declaratins
   
   //start function body

   dayRange=AveRange4(pos);
   if((actCl<actLowerPart1&&actOp<actLowerPart)&&  //Close&Open of PB is in higher 1/3 of PB
      (actRange>dayRange*0.5)&& //PB is not too small
      //(actLo>(preLo+preRange/3.0))&& //Low of PB is NOT lower than 1/2 of previous Bar
      (actHi-actRange*0.25>preHi)) //Nose of the PB is at least 1/3 lower than previous bar
      
   {
      if(High[ArrayMaximum(High,3,pos+3)]<High[pos+1])
         return (true);
   }
}//------------END FUNCTION-------------


//+------------------------------------------------------------------+
//| User function IsSmallBuySR - SR levels                            |
//+------------------------------------------------------------------+
bool IsSmallBuySR(int pos)//, 
{
   int countMatching,ind,takenBars,difference,matching;
   
   if (TimeDayOfWeek(Time[pos])==0)
         return(false);
   double refHigh=High[pos];
   int symbol=FindMarketIndex();
   switch(Period())
   {
      case 1440:
         switch(symbol)
         {
            case 0:
               takenBars=6;difference=4;matching=3;
               break;
            case 1:
               takenBars=6;difference=9;matching=3;
               break;
            case 2:
               takenBars=6;difference=11;matching=3;
               break;
            case 3:
               takenBars=6;difference=6;matching=3;
               break;
            case 4:
               takenBars=6;difference=6;matching=3;
               break;
            case 5:
               takenBars=6;difference=6;matching=3;
               break;        
            case 6:
               takenBars=6;difference=7;matching=3;
               break;        
            case 7:
               takenBars=6;difference=6;matching=3;
               break;        
            case 8:
               takenBars=6;difference=6;matching=3;
               break;   
            case 9:
               takenBars=6;difference=7;matching=3;
               break;        
            case 10:
               takenBars=6;difference=5;matching=3;
               break;        
            case 11:
               takenBars=6;difference=7;matching=3;
               break;        
            case 12:
               takenBars=6;difference=6;matching=3;
               break;      
            case 13:
               takenBars=5;difference=2;matching=3;
               break; 
            default:   
               takenBars=5;difference=5;matching=3;
         }
   //string tradedMarkets[]={"EURCHF","AUDUSD","USDCZK","USDCAD","EURUSD","GBPUSD","EURJPY","USDJPY","USDCHF","EURCAD","EURCZK","AUDJPY","NZDUSD","EURGBP"};
   ////                         0          1      2         3       4        5        6        7        8        9        10       11       12       13                 
      case 240:
          switch(symbol)
          {
            case 0:
               takenBars=4;difference=2;matching=3;  
               break;
            case 1:
               takenBars=4;difference=6;matching=3;
               break;
            case 2:
               takenBars=4;difference=6;matching=3;
               break;
            case 3:
               takenBars=4;difference=4;matching=3;
               break;
            case 4:
               takenBars=4;difference=4;matching=3;  
               break;
            case 5:
               takenBars=4;difference=4;matching=3;  
               break;        
            case 6:
               takenBars=4;difference=3;matching=3; 
               break;        
            case 7:
               takenBars=4;difference=2;matching=3;  
               break;        
            case 8:
               takenBars=4;difference=3;matching=3;  
               break;   
            case 9:
               takenBars=4;difference=4;matching=3;
               break;        
            case 10:
               takenBars=4;difference=3;matching=3;
               break;        
            case 11:
               takenBars=4;difference=4;matching=3;
               break;        
            case 12:
                takenBars=4;difference=4;matching=3; 
               break;      
            case 13:
               takenBars=3;difference=1;matching=3; 
               break; 
            default:   
               takenBars=4;difference=3;matching=3;
          }
//string tradedMarkets[]={"EURCHF","AUDUSD","USDCZK","USDCAD","EURUSD","GBPUSD","EURJPY","USDJPY","USDCHF","EURCAD","EURCZK","AUDJPY","NZDUSD","EURGBP"};
////                         0          1      2         3       4        5        6        7        8        9        10       11       12       13                 
      case 60:
          switch(symbol)
          {
            case 0:
               takenBars=4;difference=1;matching=3; 
               break;
            case 1:
               takenBars=4;difference=4;matching=3; 
               break;
            case 2:
               takenBars=4;difference=4;matching=3;
               break;
            case 3:
               takenBars=4;difference=2;matching=3;
               break;
            case 4:
               takenBars=4;difference=3;matching=3;
               break;
            case 5:
               takenBars=4;difference=3;matching=3;
               break;        
            case 6:
               takenBars=4;difference=3;matching=3;  
               break;        
            case 7:
               takenBars=4;difference=2;matching=3; 
               break;        
            case 8:
               takenBars=4;difference=2;matching=3; 
               break;   
            case 9:
               takenBars=4;difference=3;matching=3; 
               break;        
            case 10:
               takenBars=4;difference=2;matching=3; 
               break;        
            case 11:
               takenBars=4;difference=4;matching=3;
               break;        
            case 12:
                takenBars=4;difference=3;matching=3;
               break;      
            case 13:
               takenBars=4;difference=0;matching=3; 
               break; 
            default:   
               takenBars=4;difference=3;matching=3;
          }
   }
   
   
   
   
   for(int i=0;i<takenBars-1;i++)
   {
      
	  if(Period()==1440&&TimeDayOfWeek(Time[pos+1+i+ind])==0)
            ind++;
      if(MathAbs(refHigh-High[pos+1+i+ind])/Point<=difference)   
      {
         
         
         countMatching++;   
         if(countMatching==matching-1)
            return(true);
            
      }
      if((High[pos+1+i+ind]-refHigh)/Point>difference+1)
            return (false);
            
   }
   return(false);
}
//------------END FUNCTION-------------


//+------------------------------------------------------------------+
//| User function IsSmallSellSR - SR levels                            |
//+------------------------------------------------------------------+
bool IsSmallSellSR(int pos)
{
   int countMatching,ind,takenBars,difference,matching;
   if (TimeDayOfWeek(Time[pos])==0)
         return(false);
   
   if(takenBars==0)
   {
      switch(Period())
      {
         case 1440:
            takenBars=6;difference=6;matching=3;
            break;
         case 240:
            takenBars=4;difference=4;matching=3;  
            break;
         case 60:
            takenBars=4;difference=2;matching=3;      
            break;
      }    
   } 
   double refLow=Low[pos];
   for(int i=0;i<takenBars-1;i++)
   {
   
 	  if(Period()==1440&&TimeDayOfWeek(Time[pos+1+i+ind])==0)
            ind++;   
      if(MathAbs(refLow-Low[pos+1+i])/Point<=difference)   
      {
         
         
         countMatching++;   
         if(countMatching==matching-1)
            return(true);
            
      }
      if((refLow-Low[pos+1+i+ind])/Point>difference+1)
            return (false);
            
   }
   return(false);
}
//------------END FUNCTION-------------

//+------------------------------------------------------------------+
//| User function FindMarketIndex - helper function for IsSmallBuySR & IsSmallSellSR                        |
//+------------------------------------------------------------------+
int FindMarketIndex()//, 
{
   string tradedMarkets[]={"EURCHF","AUDUSD","USDCZK","USDCAD","EURUSD","GBPUSD","EURJPY","USDJPY","USDCHF","EURCAD","EURCZK","AUDJPY","NZDUSD","EURGBP"};
   //                         0          1      2         3       4        5        6        7        8        9        10       11       12       13        
   int marketCount=ArraySize(tradedMarkets);
   string mySymbol=Symbol();
   for(int i=0;i<marketCount;i++)
      if(tradedMarkets[i]==mySymbol)
         return (i);


}

