//+------------------------------------------------------------------+ 
//|   TRO_Stochastic_THREE_PAIRS                                     | 
//|                                                                  | 
//|   Copyright  2011, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2011, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 20
#property indicator_level2 80
#property indicator_level3 50
#property indicator_buffers 8
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 Orange
 

extern int K = 100;
extern int D = 1;
extern int S = 1;
extern string  FirstSymbol  = "GBPUSD";
extern string  SecondSymbol = "USDCHF";
extern string  ThirdSymbol  = "GBPCHF";
 
 


double buffer3[],buffer1[], buffer2[],buffer4[],buffer5[], buffer6[], buffer7[],buffer8[];
double s1, s2, diff ;
string m="", TAG, SHORTNAME;

int win;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
      m = StringSubstr(Symbol(),6,StringLen(Symbol())-6);
      SecondSymbol = SecondSymbol+m;
      if (FirstSymbol == "" )
         FirstSymbol = Symbol();
      else
         FirstSymbol = FirstSymbol+m;     
//---- indicators
SetIndexBuffer(0,buffer1);
SetIndexStyle(0,DRAW_LINE);
SetIndexLabel(0,FirstSymbol );

SetIndexBuffer(1,buffer2);
SetIndexStyle(1,DRAW_LINE);
SetIndexLabel(1,SecondSymbol );


SetIndexBuffer(2,buffer3);
SetIndexStyle(2,DRAW_LINE);
SetIndexLabel(2,ThirdSymbol );

 


SHORTNAME = "Stochastic ("+K+","+D+","+S+")";

IndicatorShortName(SHORTNAME);


IndicatorDigits(2);

TAG = "Stochastic 3 LINES" ;

//----
   deinit() ;
   return(0);
  } 

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
//----
   return(0);
  } 
  
//+------------------------------------------------------------------+
int start()
  {
  win = WindowFind(SHORTNAME);
  
   int    i,counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
      int limit=Bars-counted_bars;
      
      for(i=limit; i>=0; i--)
         {
            DoWork(FirstSymbol,  i  ) ;
            buffer1[i] = diff ;

            DoWork(SecondSymbol,  i  ) ;
            buffer2[i] = diff ;
            
            DoWork(ThirdSymbol,  i  ) ;
            buffer3[i] = diff ;              
 
                                                                                                     
         }
//----
   DoShowMessage() ;
//----
   return(0);
  }
//+------------------------------------------------------------------+

void DoWork( string sym1, int w)
{
            diff = iStochastic(sym1,0,K,D,S,0,0,0,w);
}

//+------------------------------------------------------------------+  
void DoShowMessage()
{ 
int    myChartX   = 0 ;
int    myChartY   = 10 ;

int yInc = 1 + myChartY;


  
   yInc = yInc + 15 ; 
   setObject(TAG+"STOC3",FirstSymbol  ,85+myChartX,yInc,indicator_color1); 
   setObject(TAG+"STOC31",DoubleToStr(buffer1[0],2) ,11+myChartX,yInc,indicator_color1     ,"Courier New"); 
             
   yInc = yInc + 15 ; 
   setObject(TAG+"2STOC3",SecondSymbol ,85+myChartX,yInc,indicator_color2); 
   setObject(TAG+"2STOC31",DoubleToStr(buffer2[0],2) ,11+myChartX,yInc,indicator_color2     ,"Courier New"); 

   yInc = yInc + 15 ; 
   setObject(TAG+"3STOC3",ThirdSymbol ,85+myChartX,yInc,indicator_color3); 
   setObject(TAG+"3STOC31",DoubleToStr(buffer3[0],2) ,11+myChartX,yInc,indicator_color3     ,"Courier New"); 

   

                
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{

      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,win,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
} 
//+------------------------------------------------------------------+
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}



//+------------------------------------------------------------------+ 


